 #include "lwp.h"
#include <dpmi.h>
#include <dos.h>
#include <stdlib.h>
#include <math.h>
#include <sys/farptr.h>
#include <time.h>
#include <go32.h>

#define BLOB_COUNT 40  /* 400 threads */
volatile int plot_count = 0;
void putpixel(int x, int y, char col);
void blob_proc(void);
void waitVBL(void);

int main()
{
	int i;
	int ids[BLOB_COUNT];
	__dpmi_regs regs;
	
	clrscr();
	printf("\nLWP: Example 3.  Pre-emptive/Cooperative\n");
	printf("This program spawns %d threads that each draw\n", BLOB_COUNT);
	printf("a dot on the screen that moves in a random direction.\n");
	printf("Each thread yields after it draws a pixel, to smooth\n");
	printf("out the dot motion\n");
	printf("Press any key to continue...");
	fflush(stdout);
	getch();
	regs.x.ax = 0x13;
	srandom(time(0));
	__dpmi_int(0x10, &regs);
	lwp_init(8,RTC128);
	_farsetsel(_dos_ds); 
	for(i=0;(i<BLOB_COUNT) && !kbhit();i++)
		{
		ids[i] = lwp_spawn(blob_proc, 4096, 1);
		lwp_yield();  /* let the blob move a little */
		}
	while(!kbhit())
		{
		if(plot_count == BLOB_COUNT)
			{
			plot_count = 0;
			waitVBL(); 
			}	
		plot_count++;
		lwp_yield();
		}
	/* key was hit, all other threads start dying here */

	while(lwp_thread_count() > 0) 
		{
		lwp_yield();  /* wait for all the other threads to die */
		}

	getch();
	regs.x.ax = 0x3;
	__dpmi_int(0x10, &regs);
	return(0);
}

void blob_proc(void)
{
	int x, y, xspeed,yspeed ;
	char col;
	lwp_thread_disable();	
        x      = (int) (319 * (float)((float) random() / (float) RAND_MAX ));
	y      = (int) (199 * (float)((float) random() / (float) RAND_MAX ));
	col    = (int) (255 * (float)((float) random() / (float) RAND_MAX ));	
	xspeed = (int) (3   * (float)((float) random() / (float) RAND_MAX ));	
	yspeed = (int) (3   * (float)((float) random() / (float) RAND_MAX ));	
	lwp_thread_enable();
        /* loop until keypress */
	while(!kbhit())
		{
		putpixel(x,y,0);
		plot_count++;
		x+=xspeed;
		if(x>=319)
			{
			xspeed=-xspeed;
			x = 319;
			}
		if(x<=0)
			{
			xspeed=-xspeed;
			x = 0;
			}	
		y+=yspeed;
		if(y>=199)
			{
			yspeed=-yspeed;
			y=199;
			}
		if(y<=0)
			{
			yspeed=-yspeed;
			y=0;
			}
		putpixel(x,y,col);	
		lwp_yield();
		}
	putpixel(x,y,0); 
 /* erase pixel */
 /* thread dies here */
}	
 
void putpixel(int x, int y, char col)
{
	lwp_thread_disable();
	_farnspokeb(0xA0000+x+(y<<6)+(y<<8), col); 
	lwp_thread_enable();

}

void waitVBL(void)
{
	lwp_thread_disable();
	while(!(inportb(0x3DA) & 8));
	while(inportb(0x3DA) & 8);
	lwp_thread_enable();
}
